#pragma once
#include <algorithm>
#include <list>

template<typename S, typename C>
void SplitString(const S& data, C splitter, std::list<S>& output)
{
	output.clear();
	typename S::const_iterator start = data.begin();
	typename S::const_iterator loc;
	while (data.end() != (loc = std::find(start, data.end(), splitter)))
	{
		output.push_back(S(start, loc));
		start = loc + 1;
	}
	if (start != data.end())
	{
		output.push_back(S(start, data.end()));
	}
}

template<typename S, typename C>
std::list<S> SplitString(const S& data, C splitter)
{
	std::list<S> output;
	SplitString<S, C>(data, splitter, output);
	return output;
}