#pragma once
#include "stdafx.h"
template<typename STRING, typename VECTOR, typename CHAR>
void VectorFromString(const STRING& str, VECTOR& vec)
{
	vec.clear();
	try
	{
		vec.resize(str.length() * sizeof(CHAR));
		if (vec.size() > 0) memcpy(&vec[0], str.c_str(), str.length() * sizeof(CHAR));
		return;
	}
	catch (...)
	{
		DEBUGLOG(_T("Caught exception in VectorFromString"));
		throw;
	}
}

template<typename STRING, typename VECTOR, typename CHAR>
VECTOR VectorFromString(const STRING& str)
{
	VECTOR output;
	VectorFromString<STRING, VECTOR, CHAR>(str, output);
	return output;
}

template<typename FROM, typename TO>
inline TO TxVector(const FROM& v)
{
	return TO(v.begin(), v.end());
}