/*#include <iostream>

using namespace std;

int main()
{
	cout << "Hello CMake." << endl;
	return 0;
}*/

// http://www.linux-pam.org/Linux-PAM-html/adg-example.html
/*
  This program was contributed by Shane Watts
  [modifications by AGM and kukuk]

  You need to add the following (or equivalent) to the
  /etc/pam.d/check_user file:
  # check authorization
  auth       required     pam_unix.so
  account    required     pam_unix.so
 */
#include "stdafx.h"

#include <security/pam_appl.h>
#include <security/pam_misc.h>
#include <stdio.h>

static struct pam_conv conv = {
    misc_conv,
    NULL
};

int main(int argc, char* argv[])
{
    pam_handle_t* pamh = NULL;
    int retval;
    const char* user = "nobody";

    if (argc != 3) {
        fprintf(stderr, "Version: %s\nUsage: %s <service> <username>\n", VERSION, argv[0]);
        exit(1);
    }
    const char* service = "passwd";
    service = argv[1];
    user = argv[2];

    retval = pam_start(service, user, &conv, &pamh);
    fprintf(stdout, "Start result: %d\n", retval);

    if (retval == PAM_SUCCESS)
        retval = pam_authenticate(pamh, 0);    /* is user really user? */
    fprintf(stdout, "Auth result: %d\n", retval);

    if (retval == PAM_SUCCESS)
        retval = pam_acct_mgmt(pamh, 0);       /* permitted access? */

    /* This is where we have been authorized or not. */

    if (retval == PAM_SUCCESS) {
        fprintf(stdout, "Authenticated\n");
    }
    else {
        fprintf(stdout, "Not Authenticated: %d\n", retval);
    }

    if (pam_end(pamh, retval) != PAM_SUCCESS) {     /* close Linux-PAM */
        pamh = NULL;
        fprintf(stderr, "check_user: failed to release authenticator\n");
        exit(1);
    }

    return (retval == PAM_SUCCESS ? 0 : 1);       /* indicate success */
}
